    package com.croftsoft.apps.tpu;
    
    import java.util.*;

    /***********************************************************************
    * Demonstrations of using ThreePhaseUpdate correctly single-threaded.
    * 
    * @version
    *   $Id: ThreePhaseUpdateDemo1.java 16 2009-06-06 01:01:10Z croft $
    * @since
    *   2009-05-10
    * @author
    *   <a href="http://www.CroftSoft.com/">David Wallace Croft</a>
    ***********************************************************************/

    public final class  ThreePhaseUpdateDemo1
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    {
      
    private static final int
      GRID_WIDTH  = 30,
      GRID_HEIGHT = 30;
      
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////

    public static void  main ( final String [ ]  args )
    ////////////////////////////////////////////////////////////////////////
    {
      update1 ( );
      
      update2 ( );
      
      update3 ( );
    }
    
    public static void  update1 ( )
    ////////////////////////////////////////////////////////////////////////
    {
      final Random  random = new Random ( );
      
      final ThreePhaseUpdateGrid  grid
        = new ThreePhaseUpdateGrid ( random, GRID_WIDTH, GRID_HEIGHT );
      
      final ThreePhaseUpdate [ ]  threePhaseUpdates = grid.getCells ( );
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.access ( );
      }
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.digest ( );
      }
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.mutate ( );
      }
    }
    
    public static void  update2 ( )
    ////////////////////////////////////////////////////////////////////////
    {
      final Random  random = new Random ( );
      
      final ThreePhaseUpdateGrid  grid
        = new ThreePhaseUpdateGrid ( random, GRID_WIDTH, GRID_HEIGHT );
      
      final ThreePhaseUpdate [ ]  threePhaseUpdates = grid.getCells ( );
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.access ( );
        
        threePhaseUpdate.digest ( );
      }
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.mutate ( );
      }
    }
    
    public static void  update3 ( )
    ////////////////////////////////////////////////////////////////////////
    {
      final Random  random = new Random ( );
      
      final ThreePhaseUpdateGrid  grid
        = new ThreePhaseUpdateGrid ( random, GRID_WIDTH, GRID_HEIGHT );
      
      final ThreePhaseUpdate [ ]  threePhaseUpdates = grid.getCells ( );
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.access ( );
      }
      
      for ( final ThreePhaseUpdate  threePhaseUpdate : threePhaseUpdates )
      {
        threePhaseUpdate.digest ( );
        
        threePhaseUpdate.mutate ( );
      }
    }
    
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
    }